/* Ad-hoc programming editor for DOSBox -- (C) 2011-03-08 Joel Yliluoma */
#include <string.h>

static const char Mario[] =
//     0123456789ABCDEF        0123456789ABCDEF        0123456789ABCDEF
//12345""""""""""""""""012345________________012345________________012345
/*
"??????      #####     ??????                ??????      #####     ??????"
"??????     #########  ??????       #####    ??????     #########  ??????"
"??????     %%%''%'    ??????      ######### ??????     %%%''%'    ??????"
"??????    %'%'''%'''  ??????      %%%''%'   ??????    %'%'''%'''  ??????"
"??????    %'%%'''%''' ??????     %'%'''%''' ??????    %'%%'''%''' ??????"
"??????    %%''''%%%%  ??????     %'%%'''%'' ??????    %%''''%%%%  ??????"
"??????      '''''''   ??????     %%''''%%%% ??????      '''''''   ??????"
"??????     %%#%%%     ??????       '''''''  ??????   %%%%##%%     ??????"
"??????    %%%%##%%    ??????      %%%%#% '  ?????? ''%%%%###%%%'''??????"
"??????    %%%##'##'   ??????     '%%%%%%''' ?????? ''' %%#'###%%''??????"
"??????    %%%%#####   ??????    ''#%%%%%''  ?????? ''  #######  % ??????"
"??????    #%%'''###   ??????    %%#######   ??????    #########%% ??????"
"??????     #%''###    ??????    %########   ??????   ##########%% ??????"
"??????      ###%%%    ??????   %%### ###    ??????  %%###   ###%% ??????"
"??????      %%%%%%%   ??????   %    %%%     ??????  %%%           ??????"
"??????      %%%%      ??????        %%%%    ??????   %%%          ??????"*/

//.....0123456789ABCDEF      0123456789ABCDEF  
//12345""""""""""""""""012345""""""""""""""""012345
"??????                ??????      #####     ??????"
"??????      ######    ??????     #'''''###  ??????"
"??????     #''''''##  ??????    #'''''''''# ??????"
"??????    #'''''''''# ??????    ###'.#.###  ??????"
"??????    ###..#.###  ??????   #..##.#....# ??????"
"??????   #..##.#....# ??????   #..##..#...# ??????"
"??????   #..##..#...# ??????    ##...#####  ??????"
"??????    ##...#####  ??????    ###.....#   ??????"
"??????     ##.....#   ??????  ##'''##''###  ??????"
"??????    #''##''#    ?????? #..''''##''#'# ??????"
"??????   #''''##''#   ?????? #..'''######'.#??????"
"??????   #''''#####   ??????  #..####.##.#.#??????"
"??????    #...##.##   ??????  .#########''# ??????"
"??????    #..'''###   ??????  #''######'''# ??????"
"??????     #'''''#    ??????  #'''#  #'''#  ??????"
"??????      #####     ??????   ###    ###   ??????";

static const char Mario21[] =
"??????                ??????       #####    ??????"
"??????       #####    ??????     ##'''Y'#   ??????"
"??????     ##'''Y'#   ??????    #''++YYY#   ??????"
"??????    #''++YYY#   ??????   #+'++######  ??????"
"??????   #+'++######  ??????  #+++######### ??????"
"??????  #+++######### ??????  #.###:#:#:    ??????"
"??????  #.###:#:#:    ?????? #.#.#:.#.#.##  ??????"
"?????? #.#.#:.#.#.##  ?????? #:#.##.......# ??????"
"?????? #:#.##.......# ?????? ##:.#..#:::::# ??????"
"?????? ##:.#..#:::::# ??????  ##::.#######  ??????"
"??????  ##::.#######  ??????   ##::::####   ??????"
"??????   ###:::####   ??????   #+#####%     ??????"
"??????    #+####%     ??????   #++'#,11%    ??????"
"??????   #++',,11%    ??????  ##...#..1.%## ??????"
"??????   ####,..1.%   ?????? ###..#,..1.#Y##??????"
"??????   #...#..1.%   ?????? ###..#,,,1%####??????"
"??????   #..#,,,11%   ?????? ##%##,,,,%#### ??????"
"??????   #..#,,%,%    ?????? ##Y# %%%% #### ??????"
"??????    #######     ??????  ##        ##  ??????"
"??????    ####Y#Y#    ??????                ??????"
"??????    ########    ??????                ??????";
static const char Mario32[] =
//"""""""0123456789ABCDEF0123456789ABCDEFGH""""""""0123456789ABCDEF0123456789ABCDEFGH""""""""0123456789ABCDEF0123456789ABCDEFGH""""""""
"????????                                  ????????                                  ????????                                  ????????"
"????????                                  ????????                                  ????????                                  ????????"
"????????                                  ????????                                  ????????                                  ????????"
"????????           ##   ##                ????????           ##   ##                ????????           ##   ##                ????????"
"????????           #.######               ????????           #.######               ????????           #.######               ????????"
"????????           #..#,,,,#              ????????           #..#,,,,#              ????????           #..#,,,,#              ????????"
"????????          #,..,,,,,#              ????????          #,..,,,,,#              ????????          #,..,,,,,#              ????????"
"????????         #,,.,,,,,,,#             ????????         #,,.,,,,,,,#             ????????         #,,.,,,,,,,#             ????????"
"????????         #,,,,,,,,,,#             ????????         #,,,,,,,,,,#             ????????         #,,,,,,,,,,#             ????????"
"????????        #,,,,,,,,,,,#             ????????        #,,,,,,,,,,,#             ????????        #,,,,,,,,,,,#             ????????"
"????????        #,,,,,,####,#             ????????        #,,,,,,####,#             ????????        #,,,,,,####,#             ????????"
"????????        #,,,,,#..#.#              ????????        #,,,,,#..#.#              ????????        #,,,,,#..#.#              ????????"
"????????        #,,,,,...#.###            ????????        #,,,,,...#.###            ????????        #,,,,,...#.###            ????????"
"????????        #,,,,,........#######     ????????        #,,,,,........#######     ????????        #,,,,,........#######     ????????"
"????????         #,,,,..#.....##....##    ????????         #,,,,..#.....##....##    ????????         #,,,,..#.....##....##    ????????"
"????????         #,,,,.###...##.......#   ????????         #,,,,.###...##.......#   ????????         #,,,,.###...##.......#   ????????"
"????????          ##,,...#####.######..## ????????          ##,,...#####.######..## ????????          ##,,...#####.######..## ????????"
"????????           ####....#..#,,,,,,#...#????????           ####....#..#,,,,,,#...#????????           ####....#..#,,,,,,#...#????????"
"????????          #,#,,####.###,,,,,,###..????????          #,#,,####.###,,,,,,###..????????          #,#,,####.###,,,,,,###..????????"
"????????          ##,,,,,####,,#,,,,#,,###????????          ##,,,,,####,,#,,,,#,,###????????          ##,,,,,####,,#,,,,#,,###????????"
"????????         #,#,,,,,,,##,,,####,,,,,#????????         #,#,,,,,,,##,,,####,,,,,#????????         #,#,,,,,,,##,,,####,,,,,#????????"
"????????         #,,#,,,,,#..#,#,,,,#,,,##????????         #,,#,,,,,#..#,#,,,,#,,,##????????         #,,#,,,,,#..#,#,,,,#,,,##????????"
"????????       ###,,,##,,#....#,,,,,,#,## ????????    ######,,,##,,#....#,,,,,,#,## ???????? #########,,,##,,#....#,,,,,,#,## ????????"
"????????     ##..#,,,,,###....#,,,,,,,#,# ????????  ###,,..#,,,,,###....#,,,,,,,#,# ????????##,..,,...#,,,,###....#,,,,,,,#,# ????????"
"????????    #.,..#,,,,,,,##..##,,,,,,#,#  ???????? ##..,,..#,,,,,,,##..##,,,,,,#,#  ????????#,,..,,...#,,,,,,##..##,,,,,,#,#  ????????"
"????????   #...,.#,,,,,,,..##,,#,,,,#,,#  ???????? #,,..,,#,,,,,,,,..##,,#,,,,#,,#  ????????#,,..,,..#,,,,,,,,.##.##,,,,#,,#  ????????"
"????????  #,,..,# #,,,,,,,..##,,####,,#   ???????? #,,..,,#,,,,,,,,,..,#,,####,,#   ????????##,..,,##..,,,,,,,,...#,####,,#   ????????"
"????????  #,,..#  #,,,,,,,,,# ##,,,,##    ???????? ##,,###,,,,,,,#,,,,,.##,,,,##    ???????? #######..,,,,,###,...##,,,,##    ????????"
"????????  #,,,#    #,,,,,,##   ######     ????????  ###   #.,,,,# #,,,..#######     ????????       #..,,###   #..########     ????????"
"????????  ##,,#    #,,,,,#                ????????        #..,,#   #,..#            ????????       #..##       ###            ????????"
"????????   ###     #......#               ????????         #....#  #..#             ????????        ##                        ????????"
"????????           ########               ????????          ####    ##              ????????                                  ????????"
;

static unsigned OverlayMarioByte(
    unsigned pose,
    register unsigned y, register unsigned absx,
    register unsigned char OriginalByte,
    signed int MarioOffset)
{
    const unsigned NumMarioPoses = VidCellHeight >= 29 ? 3 : 2;

    const char* data =
        VidCellHeight <= 16
      ?    (Mario + 6 + pose * unsigned(16+6)
          + y * unsigned(6*(NumMarioPoses+1)+16*NumMarioPoses)
          + MarioOffset)
      : VidCellHeight <= 20
      ?    (Mario21 + 6 + pose * unsigned(16+6)
          + y * unsigned(6*(NumMarioPoses+1)+16*NumMarioPoses)
          + MarioOffset)
      :    (Mario32 + 8 + pose * unsigned(34+8)
          + y * unsigned(8*(NumMarioPoses+1)+34*NumMarioPoses)
          + MarioOffset);

    static const unsigned char dither4x4[16] =
        {0,12,3,15, 8,4,11,7, 2,14,1,13, 10,6,9,5};
    const unsigned char* dithline = dither4x4 + (((y+MarioTimer) & 3u) * 4u);

    unsigned char byte = 0x00;
    for(register unsigned x=0; x<8; ++x)
    {
        unsigned char dithval = dithline[ (x+absx)&3 ];
        register unsigned char bit = 1;
        switch(*data++ / 3)
        {
            case '.' / 3: // 15
                bit = 0;            // 0%
                break;
            case 'Y' / 3: // 29
                bit = dithval < 2;  // 12.5%
                break;
            case ':' / 3: // 19
                bit = dithval < 4;  // 25%
                break;
            case ',' / 3: // 14
            case '\'' / 3: // 13
                bit = dithval >> 3; // 50%
                break;
            case '%' / 3: // 12
                bit = dithval >= 4; // 75%
                break;
            case '#' / 3: // 11
                break;              // 100%
            default:
            case '?' / 3: // 21
            case ' ' / 3: // 10
                // transparent, no change
                byte |= OriginalByte & (0x80 >> x);
                continue;
        }
        if(bit)
            byte |= 1u << (7-x);
    }
    return byte;
}

void MarioTranslate(
    unsigned short* model,
    unsigned short* target,
    unsigned width)
{
    const unsigned room_left   = 240;
    const unsigned room_right  = 8;
    const unsigned room_wide   = width * (FatMode ? 16 : 8);
    const unsigned xspanlength = room_wide + room_left + room_right;
    //const unsigned twospans = xspanlength * 2u;
    unsigned long mt = MarioTimer / 2;
    const unsigned poses = (VidCellHeight >= 29) ? 4u : 2u;

    const unsigned MarioStepInterval = VidCellHeight >= 29 ? 5 : 7;
    //if(VidCellHeight >= 29) mt *= 2;

    unsigned marioframe = (mt / MarioStepInterval) % poses;
    if(marioframe == 3) marioframe = 1;

    /*
    unsigned mariopos = timer % twospans;
    int mariox = mariopos < xspanlength
        ? (int)mariopos - (int)room_left
        : (int)room_wide + (int)room_right - (int)(mariopos - xspanlength);
    */
    int mariox = (mt % xspanlength) - room_left;

    unsigned char RevisedFontData[ 6 * 32 ];

    const unsigned MarioColor = 0x0800;
    const unsigned base = FatMode ? 0x80 : 0xC0;
    const unsigned short chartable[6] =
        { base + 0x0 + MarioColor,
          base + 0x3 + MarioColor,
          base + 0x4 + MarioColor,
          base + 0x8 + MarioColor,
          base + 0x9 + MarioColor,
          base + 0xD + MarioColor
        };
    unsigned fontdatasize  = 0;
    unsigned numchars      = 0;
    unsigned spritewide = 16;
    if(VidCellHeight >= 29) spritewide = 34;
    for(int basex = mariox - (mariox % 8)
      ; basex < mariox + spritewide
     && basex < room_wide
      ; basex += 8)
    {
        if(basex < 0) continue;

        int offset = basex - mariox;
        unsigned short ch = model[basex >> 3];
        if( (ch & 0xFF) == 0xDC )
            ch = (ch & 0xFF00u) | 0x20;

        const unsigned char* SourceFontPtr = VgaFont + ((ch & 0xFF) * VidCellHeight);

        for(unsigned y=0; y<VidCellHeight; ++y)
        {
            RevisedFontData[fontdatasize++] =
                OverlayMarioByte(marioframe,y,mariox, SourceFontPtr[y], offset);
        }
        model[basex >> 3] = (ch & 0xF000u) | chartable[numchars++];
    }

    memcpy(target, model, room_wide/4);
#ifdef __BORLANDC__
    if(numchars > 0)
    {
        // Update VGA font:
        _asm {
            push es
            push bp
            push di
             mov ax, 0x1100
             mov bh, 0
             mov bl, VidCellHeight
             mov di, base
             mov si, bx
             xchg bl,bh
             push ss
             pop es
             lea bp, offset RevisedFontData
             lea dx, [di+0x0]; mov cx, 1; int 0x10
              add bp, si
              shl si, 1
             lea dx, [di+0x3]; mov cx, 2; int 0x10
              add bp, si
             lea dx, [di+0x8]; mov cx, 2; int 0x10
              add bp, si
             lea dx, [di+0xD]; mov cx, 1; int 0x10
            pop di
            pop bp
            pop es
        }
    }
#endif
}

#ifdef __BORLANDC__
static unsigned short rate=120U, Clock=0u, Counter=0x1234DCUL/rate;
static void (interrupt *OldI08)();
static void interrupt MarioI08()
{
    ++MarioTimer;
    _asm {
        mov ax, Counter
        add Clock, ax
        jnc P1
    }
    OldI08();
    goto P2;
P1: _asm { mov al, 0x20; out 0x20, al }
P2:;
}
#endif

void FixMarioTimer()
{
#ifdef __BORLANDC__
    disable();
    _asm { mov al, 0x34;    out 0x43, al
           mov ax, Counter; out 0x40, al
           mov al, ah;      out 0x40, al }
    enable();
#endif
}

void InstallMario()
{
#ifdef __BORLANDC__
    disable();
    OldI08 = (void(interrupt*)()) *(void **)MK_FP(0, 8*4);
    *(void **)MK_FP(0, 8*4) = (void *)MarioI08;
    FixMarioTimer();
#endif
}

void DeInstallMario()
{
#ifdef __BORLANDC__
    disable();
    *(void **)MK_FP(0, 8*4) = (void *)OldI08;
    _asm { mov al, 0x34;    out 0x43, al
           xor al, al;      out 0x40, al
           /*********/      out 0x40, al }
    enable();
#endif
}
